//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    2
#property indicator_color1     DeepSkyBlue
#property indicator_color2     PaleVioletRed
#property indicator_width1     2
#property indicator_level1     20
#property indicator_level2     50
#property indicator_level3     80
#property indicator_levelcolor DimGray

//
//
//
//
//
//

extern string TimeFrame   = "Current time frame";
extern string Symbols     = "GBPUSD;EURJPY;AUDUSD;NZDJPY;EURUSD;GBPJPY;NZDUSD;AUDJPY;CHFJPY;EURCHF;GBPCHF;USDJPY;CADJPY;EURGBP";
extern int    PeriodRSI   = 13;
extern int    PeriodStoch = 12;
extern int    PeriodSK    =  6;
extern int    PeriodSD    =  3;
extern int    SmoothMode  = MODE_SMA;
extern bool   Interpolate = true;


//
//
//
//
//

double dtosc[];
double dtoss[];
double storsi[];
double rsibuf[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame = 0;
string aSymbol[];
int    aSize;
string prefix="NA";
string suffix="NA";
string accountCompany;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,dtosc);
   SetIndexBuffer(1,dtoss);
   SetIndexBuffer(2,storsi);
   SetIndexBuffer(3,rsibuf);
   
   //
   //
   //
   //
   //
   
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);

      //
      //
      //
      //
      //
      
      Symbols = stringUpperCase(StringTrimLeft(StringTrimRight(Symbols)));
      if (StringSubstr(Symbols,StringLen(Symbols),1) != ";")
                       Symbols = StringConcatenate(Symbols,";");

         //
         //
         //
         //
         //                                   

         int  s      = 0;
         int  i      = StringFind(Symbols,";",s);
         string current;
            while (i > 0)
            {
               current = StringSubstr(Symbols,s,i-s);
               if (iClose(current,0,0) > 0) {
                     ArrayResize(aSymbol,ArraySize(aSymbol)+1);
                                 aSymbol[ArraySize(aSymbol)-1] = current; }
                                 s = i + 1;
                                     i = StringFind(Symbols,";",s);
            }
            aSize = ArraySize(aSymbol);

   //
   //
   //
   //
   //

   IndicatorShortName(timeFrameToString(timeFrame)+" multi symbol dtosc");
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double sWeights[];

//
//
//
//
//

int start()
{
   int i,r,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { dtosc[0] = limit; return(0); }

   //
   //
   //
   //
   //

      if (calculateValue)
      {
         for (i=limit; i>=0; i--)
         {
            rsibuf[i] = iRSI(NULL,0,PeriodRSI,PRICE_CLOSE,i); 
            double min = rsibuf[ArrayMinimum(rsibuf,PeriodStoch,i)];
            double max = rsibuf[ArrayMaximum(rsibuf,PeriodStoch,i)];
            if (max!=min)
                  storsi[i] = 100.0*((rsibuf[i]-min)/(max-min));
            else  storsi[i] = 0;
         }   
         for (i=limit; i>=0; i--) dtosc[i]=iMAOnArray(storsi,0,PeriodSK,0,SmoothMode,i);
         for (i=limit; i>=0; i--) dtoss[i]=iMAOnArray(dtosc ,0,PeriodSD,0,SmoothMode,i);
         return(0);      
      }

   //
   //
   //
   //
   //

      double weight;
      double weights = 0;
      ArrayInitialize(sWeights,0);
      
         if (suffix=="NA" || prefix=="NA" || accountCompany!=AccountCompany()) getPrefixSuffix(prefix,suffix);
         for (i=0; i<aSize; i++)
         {
               limit  = getLimit(limit,prefix+aSymbol[i]+suffix);
               weight = MarketInfo(prefix+aSymbol[i]+suffix,MODE_TICKVALUE);    
                  if (weight==0)
                     {
                        Comment("missing symbol "+prefix+aSymbol[i]+suffix); return(0);
                     }
               weights += weight;
               if (ArraySize(sWeights)<(i+1)) ArrayResize(sWeights,i+1); sWeights[i] = weight;
         }
         Comment("");
   
      //
      //
      //
      //
      //
   
      for (i=limit; i>=0; i--)
      {
         dtosc[i] = 0;
         dtoss[i] = 0;
         for (int k=0; k<aSize; k++)
         {
            int y = iBarShift(prefix+aSymbol[k]+suffix,timeFrame,Time[i]);
               dtosc[i] += iCustom(prefix+aSymbol[k]+suffix,timeFrame,indicatorFileName,"calculateValue","",PeriodRSI,PeriodStoch,PeriodSK,PeriodSD,SmoothMode,0,y)*sWeights[k]/weights;
               dtoss[i] += iCustom(prefix+aSymbol[k]+suffix,timeFrame,indicatorFileName,"calculateValue","",PeriodRSI,PeriodStoch,PeriodSK,PeriodSD,SmoothMode,1,y)*sWeights[k]/weights;
         }
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
              interpolate(dtosc,iTime(NULL,timeFrame,iBarShift(NULL,timeFrame,Time[i])),i);
              interpolate(dtoss,iTime(NULL,timeFrame,iBarShift(NULL,timeFrame,Time[i])),i);
      }      
   
   //
   //
   //
   //
   //
   
   return(0);
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void interpolate(double& buffer[], datetime time, int i)
{
   for (int n = 1; (i+n) < Bars && Time[i+n] >= time; n++) continue;
   
   //
   //
   //
   //
   //
   
   if (buffer[i] == EMPTY_VALUE || buffer[i+n] == EMPTY_VALUE) n=-1;
               double increment = (buffer[i+n] - buffer[i])/ n;
   for (int k = 1; k < n; k++)     buffer[i+k] = buffer[i] + k*increment;
}

//
//
//
//
//

int getLimit(int limit, string symbol)
{
   if (symbol!=Symbol())
          limit = MathMax(MathMin(Bars-1,iCustom(symbol,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()),limit);
   return(limit);
}
 
//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#import "kernel32.dll"
    int _lclose (int);
    int _lopen  (string,int);
    int _llseek (int,int,int);
    int _lread  (int,string,int);
#import
#define sectorSize  1936
#define HFILE_ERROR -1
string  _symbols[];

//
//
//
//
//

void getSymbolsList()
{
   ArrayResize(_symbols,0);
   int fileHandle = _lopen(TerminalPath()+"\\history\\"+AccountServer()+"\\symbols.raw",0);
   if (fileHandle == HFILE_ERROR) return;
    
   //
   //
   //
   //
   //

   for(int i=0;; i++)
   {
      _llseek(fileHandle, i * sectorSize, 0);
      string symbolName = "123456789012";       
                        if (_lread (fileHandle, symbolName, 12) != 12) break;
             symbolName = StringSubstr(symbolName, 0);

             //
             //
             //
             //
             //

      ArrayResize(_symbols,i+1); _symbols[i] = StringTrimLeft(StringTrimRight(symbolName));
   } 
   _lclose(fileHandle);
}

//
//
//
//
//

void getPrefixSuffix(string& prefix, string& suffix)
{ 
   getSymbolsList();   
   int limit = ArraySize(_symbols);
   if (limit<1) return;
         prefix="";
         suffix="";
            accountCompany=AccountCompany();
   //
   //
   //
   //
   //
   
   for(int i=0; i<limit; i++)
   {
      string symbolName = _symbols[i];
             int pos = StringFind(symbolName,"EURUSD",0);
             if (pos > -1)
             {
                if (pos>0)                         prefix = StringSubstr(symbolName,0,pos);
                if ((pos+6)<StringLen(symbolName)) suffix = StringSubstr(symbolName,(pos+6),0);
                break;
             }
   } 
}